LibreOffice: cppu::OPropertySetHelper Class Reference

LibreOffice LibreOffice 6.0 SDK C/C++ API Reference

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
cppu::OPropertySetHelper Class Referenceabstract

This abstract class maps the methods of the interfaces XMultiPropertySet, XFastPropertySet and XPropertySet to the methods getInfoHelper, convertFastPropertyValue, setFastPropertyValue_NoBroadcast and getFastPropertyValue. More...

`#include <propshlp.hxx>`

Inheritance diagram for cppu::OPropertySetHelper:

## Public Member Functions
| OPropertySetHelper (OBroadcastHelper &rBHelper)
| OPropertySetHelper (OBroadcastHelper &rBHelper, bool bIgnoreRuntimeExceptionsWhileFiring)
| Constructor. More...
| OPropertySetHelper (OBroadcastHelper &rBHelper, IEventNotificationHook *i_pFireEvents, bool bIgnoreRuntimeExceptionsWhileFiring=false)
| Constructor. More...
virtual css::uno::Any | queryInterface (const css::uno::Type &rType) SAL_OVERRIDE
| Only returns a reference to XMultiPropertySet, XFastPropertySet, XPropertySet and XEventListener. More...
css::uno::Sequence< css::uno::Type > | getTypes ()
| eases implementing XTypeProvider::getTypes, returns the types of XMultiPropertySet, XFastPropertySet, XPropertySet More...
void | disposing ()
| Send a disposing notification to the listeners in the containers aBoundLC and aVetoableLC. More...
virtual void | setPropertyValue (const ::rtl::OUString &rPropertyName, const css::uno::Any &aValue) SAL_OVERRIDE
| Throw UnknownPropertyException or PropertyVetoException if the property with the name rPropertyName does not exist or is readonly. More...
virtual css::uno::Any | getPropertyValue (const ::rtl::OUString &aPropertyName) SAL_OVERRIDE
| Throw UnknownPropertyException if the property with the name rPropertyName does not exist. More...
virtual void | addPropertyChangeListener (const ::rtl::OUString &aPropertyName, const css::uno::Reference< css::beans::XPropertyChangeListener > &aListener) SAL_OVERRIDE
| Ignored if the property is not bound. More...
virtual void | removePropertyChangeListener (const ::rtl::OUString &aPropertyName, const css::uno::Reference< css::beans::XPropertyChangeListener > &aListener) SAL_OVERRIDE
| Ignored if the property is not bound. More...
virtual void | addVetoableChangeListener (const ::rtl::OUString &aPropertyName, const css::uno::Reference< css::beans::XVetoableChangeListener > &aListener) SAL_OVERRIDE
| Ignored if the property is not constrained. More...
virtual void | removeVetoableChangeListener (const ::rtl::OUString &aPropertyName, const css::uno::Reference< css::beans::XVetoableChangeListener > &aListener) SAL_OVERRIDE
| Ignored if the property is not constrained. More...
virtual void | setFastPropertyValue (sal_Int32 nHandle, const css::uno::Any &rValue) SAL_OVERRIDE
| Throw UnknownPropertyException or PropertyVetoException if the property with the name rPropertyName does not exist or is readonly. More...
virtual css::uno::Any | getFastPropertyValue (sal_Int32 nHandle) SAL_OVERRIDE
virtual void | setPropertyValues (const css::uno::Sequence< ::rtl::OUString > &PropertyNames, const css::uno::Sequence< css::uno::Any > &Values) SAL_OVERRIDE
virtual css::uno::Sequence< css::uno::Any > | getPropertyValues (const css::uno::Sequence< ::rtl::OUString > &PropertyNames) SAL_OVERRIDE
virtual void | addPropertiesChangeListener (const css::uno::Sequence< ::rtl::OUString > &PropertyNames, const css::uno::Reference< css::beans::XPropertiesChangeListener > &Listener) SAL_OVERRIDE
virtual void | removePropertiesChangeListener (const css::uno::Reference< css::beans::XPropertiesChangeListener > &Listener) SAL_OVERRIDE
virtual void | firePropertiesChangeEvent (const css::uno::Sequence< ::rtl::OUString > &PropertyNames, const css::uno::Reference< css::beans::XPropertiesChangeListener > &Listener) SAL_OVERRIDE

## Static Public Member Functions
static css::uno::Reference< css::beans::XPropertySetInfo > | createPropertySetInfo (IPropertyArrayHelper &rProperties)
| The property sequence is created in the call. More...

## Protected Member Functions
void | fire (sal_Int32 *pnHandles, const css::uno::Any *pNewValues, const css::uno::Any *pOldValues, sal_Int32 nCount, sal_Bool bVetoable)
| This method fire events to all registered property listeners. More...
void | setFastPropertyValues (sal_Int32 nSeqLen, sal_Int32 *pHandles, const css::uno::Any *pValues, sal_Int32 nHitCount)
| Set multiple properties with the handles. More...
virtual IPropertyArrayHelper & | getInfoHelper ()=0
| This abstract method must return the name to index table. More...
virtual sal_Bool | convertFastPropertyValue (css::uno::Any &rConvertedValue, css::uno::Any &rOldValue, sal_Int32 nHandle, const css::uno::Any &rValue)=0
| Converted the value rValue and return the result in rConvertedValue and the old value in rOldValue. More...
virtual void | setFastPropertyValue_NoBroadcast (sal_Int32 nHandle, const css::uno::Any &rValue)=0
| The same as setFastProperyValue; nHandle is always valid. More...
virtual void | getFastPropertyValue (css::uno::Any &rValue, sal_Int32 nHandle) const =0
| The same as getFastProperyValue, but return the value through rValue and nHandle is always valid. More...
void | setDependentFastPropertyValue (sal_Int32 i_handle, const css::uno::Any &i_value)
| sets an dependent property's value More...
| ~OPropertySetHelper ()
| You must call disposing before destruction. More...

## Protected Attributes
OBroadcastHelper & | rBHelper
| The common data of a broadcaster. More...
OMultiTypeInterfaceContainerHelperInt32 | aBoundLC
| Container for the XProperyChangedListener. More...
OMultiTypeInterfaceContainerHelperInt32 | aVetoableLC
| Container for the XPropertyVetoableListener. More...
Impl *const | m_pReserved
| reserved for future use. More...

## Detailed Description

This abstract class maps the methods of the interfaces XMultiPropertySet, XFastPropertySet and XPropertySet to the methods getInfoHelper, convertFastPropertyValue, setFastPropertyValue_NoBroadcast and getFastPropertyValue.

You must derive from this class and override the methods. It provides a standard implementation of the XPropertySetInfo. The XPropertiesChangeListener are inserted in the rBHelper.aLC structure. The XPropertyChangeListener and XVetoableChangeListener with no names are inserted in the rBHelper.aLC structure. So it is possible to advise property listeners with the connection point interfaces. But only listeners that listen to all property changes.

## Constructor & Destructor Documentation

## ◆ OPropertySetHelper() [1/3]

cppu::OPropertySetHelper::OPropertySetHelper | ( | OBroadcastHelper & | rBHelper | ) |

Parameters

  rBHelper | this structure contains the basic members of a broadcaster. The lifetime must be longer than the lifetime of this object. Stored in the variable rBHelper.

## ◆ OPropertySetHelper() [2/3]

cppu::OPropertySetHelper::OPropertySetHelper | ( | OBroadcastHelper & | rBHelper,
|  | bool | bIgnoreRuntimeExceptionsWhileFiring
| ) |  |

Constructor.

Parameters

  rBHelper | this structure contains the basic members of a broadcaster. The lifetime must be longer than the lifetime of this object. Stored in the variable rBHelper.
  bIgnoreRuntimeExceptionsWhileFiring | indicates whether occurring RuntimeExceptions will be ignored when firing notifications (vetoableChange(), propertyChange()) to listeners. PropertyVetoExceptions may still be thrown. This flag is useful in an inter-process scenario when remote bridges may break down (firing DisposedExceptions).

## ◆ OPropertySetHelper() [3/3]

cppu::OPropertySetHelper::OPropertySetHelper | ( | OBroadcastHelper & | rBHelper,
|  | IEventNotificationHook * | i_pFireEvents,
|  | bool | bIgnoreRuntimeExceptionsWhileFiring = `false`
| ) |  |

Constructor.

Parameters

  rBHelper | this structure contains the basic members of a broadcaster. The lifetime must be longer than the lifetime of this object. Stored in the variable rBHelper.
  i_pFireEvents | additional event notifier
  bIgnoreRuntimeExceptionsWhileFiring | indicates whether occurring RuntimeExceptions will be ignored when firing notifications (vetoableChange(), propertyChange()) to listeners. PropertyVetoExceptions may still be thrown. This flag is useful in an inter-process scenario when remote bridges may break down (firing DisposedExceptions).

## ◆ ~OPropertySetHelper()

cppu::OPropertySetHelper::~OPropertySetHelper | ( |  | ) |
| protected

You must call disposing before destruction.

## Member Function Documentation

## ◆ addPropertiesChangeListener()

virtual void cppu::OPropertySetHelper::addPropertiesChangeListener | ( | const css::uno::Sequence< ::rtl::OUString > & | PropertyNames,
|  | const css::uno::Reference< css::beans::XPropertiesChangeListener > & | Listener
| ) |  |
| virtual

## ◆ addPropertyChangeListener()

virtual void cppu::OPropertySetHelper::addPropertyChangeListener | ( | const ::rtl::OUString & | aPropertyName,
|  | const css::uno::Reference< css::beans::XPropertyChangeListener > & | aListener
| ) |  |
| virtual

Ignored if the property is not bound.

## ◆ addVetoableChangeListener()

virtual void cppu::OPropertySetHelper::addVetoableChangeListener | ( | const ::rtl::OUString & | aPropertyName,
|  | const css::uno::Reference< css::beans::XVetoableChangeListener > & | aListener
| ) |  |
| virtual

Ignored if the property is not constrained.

## ◆ convertFastPropertyValue()

virtual sal_Bool cppu::OPropertySetHelper::convertFastPropertyValue | ( | css::uno::Any & | rConvertedValue,
|  | css::uno::Any & | rOldValue,
|  | sal_Int32 | nHandle,
|  | const css::uno::Any & | rValue
| ) |  |
| protectedpure virtual

Converted the value rValue and return the result in rConvertedValue and the old value in rOldValue.

A IllegalArgumentException is thrown. The method is not implemented in this class. After this call the vetoable listeners are notified.

Parameters

  rConvertedValue | the converted value. Only set if return is true.
  rOldValue | the old value. Only set if return is true.
  nHandle | the handle of the proberty.
  rValue | the value to be converted

Returns
  true if the value converted.

Exceptions

  css::lang::IllegalArgumentException |
  css::beans::UnknownPropertyException |
  css::uno::RuntimeException |

## ◆ createPropertySetInfo()

static css::uno::Reference< css::beans::XPropertySetInfo > cppu::OPropertySetHelper::createPropertySetInfo | ( | IPropertyArrayHelper & | rProperties | ) |
| static

The property sequence is created in the call.

The interface isn't used after the call.

## ◆ disposing()

void cppu::OPropertySetHelper::disposing | ( |  | ) |

Send a disposing notification to the listeners in the containers aBoundLC and aVetoableLC.

See also
  OComponentHelper

## ◆ fire()

void cppu::OPropertySetHelper::fire | ( | sal_Int32 * | pnHandles,
|  | const css::uno::Any * | pNewValues,
|  | const css::uno::Any * | pOldValues,
|  | sal_Int32 | nCount,
|  | sal_Bool | bVetoable
| ) |  |
| protected

This method fire events to all registered property listeners.

Parameters

  pnHandles | the id's of the properties that changed.
  pNewValues | the new values of the properties.
  pOldValues | the old values of the properties.
  nCount | the number of elements in the arrays pnHandles, pNewValues and pOldValues.
  bVetoable | true means fire to VetoableChangeListener, false means fire to XPropertyChangedListener and XMultiPropertyChangedListener.

## ◆ firePropertiesChangeEvent()

virtual void cppu::OPropertySetHelper::firePropertiesChangeEvent | ( | const css::uno::Sequence< ::rtl::OUString > & | PropertyNames,
|  | const css::uno::Reference< css::beans::XPropertiesChangeListener > & | Listener
| ) |  |
| virtual

## ◆ getFastPropertyValue() [1/2]

virtual css::uno::Any cppu::OPropertySetHelper::getFastPropertyValue | ( | sal_Int32 | nHandle | ) |
| virtual

Exceptions

  css::beans::UnknownPropertyException | if the property with the handle nHandle does not exist.

## ◆ getFastPropertyValue() [2/2]

virtual void cppu::OPropertySetHelper::getFastPropertyValue | ( | css::uno::Any & | rValue,
|  | sal_Int32 | nHandle
| ) |  | const
| protectedpure virtual

The same as getFastProperyValue, but return the value through rValue and nHandle is always valid.

The method is not implemented in this class.

## ◆ getInfoHelper()

virtual IPropertyArrayHelper& cppu::OPropertySetHelper::getInfoHelper | ( |  | ) |
| protectedpure virtual

This abstract method must return the name to index table.

This table contains all property names and types of this object. The method is not implemented in this class.

## ◆ getPropertyValue()

virtual css::uno::Any cppu::OPropertySetHelper::getPropertyValue | ( | const ::rtl::OUString & | aPropertyName | ) |
| virtual

Throw UnknownPropertyException if the property with the name rPropertyName does not exist.

## ◆ getPropertyValues()

virtual css::uno::Sequence< css::uno::Any > cppu::OPropertySetHelper::getPropertyValues | ( | const css::uno::Sequence< ::rtl::OUString > & | PropertyNames | ) |
| virtual

## ◆ getTypes()

css::uno::Sequence< css::uno::Type > cppu::OPropertySetHelper::getTypes | ( |  | ) |

eases implementing XTypeProvider::getTypes, returns the types of XMultiPropertySet, XFastPropertySet, XPropertySet

Exceptions

  css::uno::RuntimeException |

## ◆ queryInterface()

virtual css::uno::Any cppu::OPropertySetHelper::queryInterface | ( | const css::uno::Type & | rType | ) |
| virtual

Only returns a reference to XMultiPropertySet, XFastPropertySet, XPropertySet and XEventListener.

Reimplemented in cppu::OPropertySetHelper2.

## ◆ removePropertiesChangeListener()

virtual void cppu::OPropertySetHelper::removePropertiesChangeListener | ( | const css::uno::Reference< css::beans::XPropertiesChangeListener > & | Listener | ) |
| virtual

## ◆ removePropertyChangeListener()

virtual void cppu::OPropertySetHelper::removePropertyChangeListener | ( | const ::rtl::OUString & | aPropertyName,
|  | const css::uno::Reference< css::beans::XPropertyChangeListener > & | aListener
| ) |  |
| virtual

Ignored if the property is not bound.

## ◆ removeVetoableChangeListener()

virtual void cppu::OPropertySetHelper::removeVetoableChangeListener | ( | const ::rtl::OUString & | aPropertyName,
|  | const css::uno::Reference< css::beans::XVetoableChangeListener > & | aListener
| ) |  |
| virtual

Ignored if the property is not constrained.

## ◆ setDependentFastPropertyValue()

void cppu::OPropertySetHelper::setDependentFastPropertyValue | ( | sal_Int32 | i_handle,
|  | const css::uno::Any & | i_value
| ) |  |
| protected

sets an dependent property's value

Sometimes setting a given property needs to implicitly modify another property's value. Calling |setPropertyValue| from within |setFastPropertyValue_NoBroadcast| is not an option here, as it would notify the property listeners while our mutex is still locked. Setting the dependent property's value directly (e.g. by calling |setFastPropertyValue_NoBroadcast| recursively) is not an option, too, since it would miss firing the property change event.

So, in such cases, you use |setDependentFastPropertyValue| from within |setFastPropertyValue_NoBroadcast|. It will convert and actually set the property value (invoking |convertFastPropertyValue| and |setFastPropertyValue_NoBroadcast| for the given handle and value), and add the property change event to the list of events to be notified when the bottom-most |setFastPropertyValue_NoBroadcast| on the stack returns.

Note: The method will not invoke veto listeners for the property.

Note: It's the caller's responsibility to ensure that our mutex is locked. This is canonically given when the method is invoked from within |setFastPropertyValue_NoBroadcast|, in other contexts, you might need to take own measures.

## ◆ setFastPropertyValue()

virtual void cppu::OPropertySetHelper::setFastPropertyValue | ( | sal_Int32 | nHandle,
|  | const css::uno::Any & | rValue
| ) |  |
| virtual

Throw UnknownPropertyException or PropertyVetoException if the property with the name rPropertyName does not exist or is readonly.

Otherwise the method convertFastPropertyValue is called, then the vetoable listeners are notified. After this the value of the property is changed with the setFastPropertyValue_NoBroadcast method and the bound listeners are notified.

## ◆ setFastPropertyValue_NoBroadcast()

virtual void cppu::OPropertySetHelper::setFastPropertyValue_NoBroadcast | ( | sal_Int32 | nHandle,
|  | const css::uno::Any & | rValue
| ) |  |
| protectedpure virtual

The same as setFastProperyValue; nHandle is always valid.

The changes must not be broadcasted in this method. The method is implemented in a derived class.

Attention
  Although you are permitted to throw any UNO exception, only the following are valid for usage: – css::beans::UnknownPropertyException – css::beans::PropertyVetoException – css::lang::IllegalArgumentException – css::lang::WrappedTargetException – css::uno::RuntimeException

Parameters

  nHandle | handle
  rValue | value

Exceptions

  css::uno::Exception |

## ◆ setFastPropertyValues()

void cppu::OPropertySetHelper::setFastPropertyValues | ( | sal_Int32 | nSeqLen,
|  | sal_Int32 * | pHandles,
|  | const css::uno::Any * | pValues,
|  | sal_Int32 | nHitCount
| ) |  |
| protected

Set multiple properties with the handles.

Parameters

  nSeqLen | the length of the arrays pHandles and Values.
  pHandles | the handles of the properties. The number of elements in the Values sequence is the length of the handle array. A value of -1 of a handle means invalid property. These are ignored.
  pValues | the values of the properties.
  nHitCount | the number of valid entries in the handle array.

## ◆ setPropertyValue()

virtual void cppu::OPropertySetHelper::setPropertyValue | ( | const ::rtl::OUString & | rPropertyName,
|  | const css::uno::Any & | aValue
| ) |  |
| virtual

Throw UnknownPropertyException or PropertyVetoException if the property with the name rPropertyName does not exist or is readonly.

Otherwise rPropertyName is changed to its handle value and setFastPropertyValue is called.

## ◆ setPropertyValues()

virtual void cppu::OPropertySetHelper::setPropertyValues | ( | const css::uno::Sequence< ::rtl::OUString > & | PropertyNames,
|  | const css::uno::Sequence< css::uno::Any > & | Values
| ) |  |
| virtual

## Member Data Documentation

## ◆ aBoundLC

OMultiTypeInterfaceContainerHelperInt32 cppu::OPropertySetHelper::aBoundLC
| protected

Container for the XProperyChangedListener.

The listeners are inserted by handle.

## ◆ aVetoableLC

OMultiTypeInterfaceContainerHelperInt32 cppu::OPropertySetHelper::aVetoableLC
| protected

Container for the XPropertyVetoableListener.

The listeners are inserted by handle.

## ◆ m_pReserved

Impl* const cppu::OPropertySetHelper::m_pReserved
| protected

reserved for future use.

finally, the future has arrived...

## ◆ rBHelper

OBroadcastHelper& cppu::OPropertySetHelper::rBHelper
| protected

The common data of a broadcaster.

Use the mutex, disposing state and the listener container.

The documentation for this class was generated from the following file:

- cppuhelper/propshlp.hxx